
/* ---------------------------------------------------------------------
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.  

   Copyright (c) 2001-2002 by Michal Ociepka <armadillo@wp.pl>

   For more info:
   http://xdefactor.republika.pl
   --------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <postgresql/libpq-fe.h>
#include <gtk/gtk.h>	
#include "callbacks.h"
#include <gdk/gdk.h>

#define CYAN_COLOR "#71f7e7"

void aktualizuj_towary_wz(gpointer *data){

	extern PGconn 		*conn;
	extern PGresult		*res;
	extern gint nFields;
	
	glong iwtb; // ilosc wierszy w tabeli
	gchar *wynik[2][4]; 
	gint i, j;
	gint bool;
	glong num_wiersza;
	gchar *mytext;
	gint wiersz;
	glong id_;	// to id towaru uzyskuje wyciagajac z zapytania
	extern GtkWidget *wz_radiobutton1, *wz_radiobutton2;
	extern GtkWidget *wz_entry10, *wz_entry11;
	
	extern gchar dynam[1024];
	gchar *buff;
	GdkColor color;

	gdk_color_parse(CYAN_COLOR, &color);
	
	buff=(char *)malloc(sizeof(dynam));
	
	gtk_clist_clear((GtkCList *) data);
	
	sprintf(buff, "SELECT id FROM towar ORDER BY nazwa , cena;");
		res = PQexec(conn, buff);


	// ilosc wierszy wygenerowanych w db to PQntuples(res)
	num_wiersza=PQntuples(res);
	iwtb = num_wiersza;
	nFields = PQnfields(res);
	bool=1;
	
	for(i=0; i < num_wiersza; i++) {
		for(j=0; j < nFields; j++){
			sprintf(buff, "SELECT id FROM towar ORDER BY nazwa , cena;");
			res = PQexec(conn, buff);
			id_ = atol(PQgetvalue(res, i, j));
			wynik[1][0] = PQgetvalue(res, i, j);

			sprintf(buff, "SELECT nazwa FROM towar ORDER BY nazwa , cena;");
			res = PQexec(conn, buff);
			wynik[1][1] = PQgetvalue(res, i, j);

			sprintf(buff, "SELECT jm FROM towar ORDER BY nazwa , cena;");
			res = PQexec(conn, buff);
			wynik[1][2] = PQgetvalue(res, i, j);

			sprintf(buff, "SELECT magazyn FROM towar ORDER BY nazwa , cena;");
			res = PQexec(conn, buff);
			wynik[1][3] = PQgetvalue(res, i, j);

			gtk_clist_append((GtkCList *) data, wynik[1]);
		}
	}


	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wz_radiobutton1)) == TRUE){

	wiersz=0;
	while(num_wiersza > 0){
		num_wiersza--;
		gtk_clist_get_text(GTK_CLIST((GtkCList *) data), wiersz, 0, &mytext);
                if(strcmp(gtk_entry_get_text(GTK_ENTRY(wz_entry10)),mytext) == 0)
			gtk_clist_select_row(GTK_CLIST((GtkCList *) data), wiersz, 1);
			//gtk_clist_set_background(GTK_CLIST(clist2), wiersz, &color);
		wiersz++;
	}


	}

	else if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wz_radiobutton2)) == TRUE){

	wiersz=0;
	sprintf(buff, "SELECT nazwa FROM towar WHERE nazwa LIKE '%s%s%s';", "%", ENTRY_GET_TEXT(wz_entry11), "%");
	
	res = PQexec(conn, buff);
	num_wiersza=PQntuples(res);

	if(PQntuples(res) == 0){
		goto next;
	}

	nFields = PQnfields(res);
	while(iwtb > 0){
		for(i=0; i < PQntuples(res); i++){
			for(j=0; j < nFields; j++){
			//while(num_wiersza > 0){
			iwtb--;
			gtk_clist_get_text(GTK_CLIST((GtkCList *)data), wiersz, 1, &mytext);
                	if(strcmp(PQgetvalue(res, i, j),mytext) == 0)
				gtk_clist_select_row(GTK_CLIST((GtkCList *)data), wiersz, 1);
				//gtk_clist_set_background(GTK_CLIST(clist2), wiersz, &color);
			wiersz++;
			//}
			}
		}

	}
	}
	next:
	//gtk_clist_set_sort_type(GTK_CLIST(clist2), GTK_SORT_ASCENDING);
	gtk_clist_set_sort_type(GTK_CLIST((GtkCList *)data), GTK_SORT_DESCENDING);
	gtk_clist_set_sort_column(GTK_CLIST((GtkCList *)data), 1);

	free(buff);
} 
