/* ---------------------------------------------------------------------
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.  

   Copyright (c) 2001-2002 by Michal Ociepka <armadillo@wp.pl>

   For more info:
   http://xdefactor.republika.pl
   --------------------------------------------------------------------- */

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <postgresql/libpq-fe.h>
#include <gtk/gtk.h>	
#include "callbacks.h"
#include <gdk/gdk.h>
#

void aktualizuj_promocje(gpointer *data){

	extern PGconn 		*conn;
	extern PGresult		*res;
	extern gint nFields;

	gchar *wynik[2][7]; 

	gint i, j;
	glong num_wiersza;
	
	extern gchar dynam[1024];
	gchar *buff;

	buff=(char *)malloc(sizeof(dynam));
	
	gtk_clist_clear((GtkCList *) data);

	sprintf(buff, "SELECT id FROM promocja ORDER BY id;");
		res = PQexec(conn, buff);

	num_wiersza = PQntuples(res);
	nFields = PQnfields(res);

	for(i=0; i < num_wiersza; i++){
		for(j = 0; j < nFields; j++){
			sprintf(buff, "SELECT id FROM promocja ORDER BY id;");
			res = PQexec(conn, buff);
			wynik[1][0] = PQgetvalue(res, i, j);
			
			/* 
			   teraz pobieram id_towaru z promocji
			   i wysylam zapytanie do tabeli towar
			   o nazwe tego produktu
			 */
			sprintf(buff, "SELECT id_towaru FROM promocja ORDER BY id;");
			res = PQexec(conn, buff);
			sprintf(buff, "SELECT nazwa FROM towar WHERE id='%s';", PQgetvalue(res, i, j));
			res = PQexec(conn, buff);
			wynik[1][1] = PQgetvalue(res, 0, 0);
			// ---end---
			
			sprintf(buff, "SELECT id_towaru FROM promocja ORDER BY id;");
			res = PQexec(conn, buff);
			wynik[1][2] = PQgetvalue(res, i, j);

			/* 
			   teraz pobieram id_towaru z promocji
			   i wysylam zapytanie do tabeli towar
			   o cene poza promocja tego produktu
			 */

			sprintf(buff, "SELECT id_towaru FROM promocja ORDER BY id;");
			res = PQexec(conn, buff);
			sprintf(buff, "SELECT cena FROM towar WHERE id='%s';", PQgetvalue(res, i, j));
			res = PQexec(conn, buff);
			wynik[1][3] = PQgetvalue(res, 0, 0);
			// ---end---

			sprintf(buff, "SELECT cena_promocyjna FROM promocja ORDER BY id;");
			res = PQexec(conn, buff);
			wynik[1][4] = PQgetvalue(res, i, j);

			sprintf(buff, "SELECT data_od FROM promocja ORDER BY id;");
			res = PQexec(conn, buff);
			wynik[1][5] = PQgetvalue(res, i, j);


			sprintf(buff, "SELECT data_do FROM promocja ORDER BY id;");
			res = PQexec(conn, buff);
			wynik[1][6] = PQgetvalue(res, i, j);

			gtk_clist_append((GtkCList *) data, wynik[1]);
		}
	}

}
